model Ex6_10
OpenIPSL.Types.VoltageKilo Vmc "motor voltage w.r.t Base in KV";
  Real Xtr1 (final unit= "per unit") "per unit reactance of transformer 1 w.r.t base(pu)";
  Real Xtr2 (final unit= "per unit") "per unit reactance of transformer 2 w.r.t base(pu)";
  Modelica.SIunits.Impedance Zb_tl "base impedance of transmission lines in ohms";
  Real Xtl (final unit= "per unit") "reactance of transmission lines(pu)";
  Real X_M1 (final unit= "per unit") "reactance of motor1";
  Real X_M2 (final unit= "per unit") "reactance of motor 2";
  OpenIPSL.Electrical.Machines.PSAT.Order2 generator(D = 0, M = 8, Sn = 300, V_0 = 1, V_b = 20, Vn = 20, ra = 0.001, x1d = 0.20) annotation(
    Placement(visible = true, transformation(origin = {-76, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenIPSL.Electrical.Machines.PSAT.Order2 motor1(D = 0, M = 8, Sn = 200, V_0 = 0.69, V_b = 20, Vn = 13.2, ra = 0.001, x1d = 0.20) annotation(
    Placement(visible = true, transformation(origin = {80, 16}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  OpenIPSL.Electrical.Machines.PSAT.Order2 motor2(D = 0, M = 8, Sn = 100, V_0 = 0.69, V_b = 20, Vn = 13.2, ra = 0.001, x1d = 0.20) annotation(
    Placement(visible = true, transformation(origin = {78, -26}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
  OpenIPSL.Electrical.Branches.PSAT.TwoWindingTransformer twoWindingTransformer1(Sn = 350, V_b = 20, Vn = 230, kT = 11.5) annotation(
    Placement(visible = true, transformation(origin = {-40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenIPSL.Electrical.Branches.PSAT.TwoWindingTransformer twoWindingTransformer2(Sn = 3 * 100, V_b = 20, Vn = (sqrt(3)) *127, kT = 16.6) annotation(
    Placement(visible = true, transformation(origin = {32, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenIPSL.Electrical.Branches.PwLine pwLine1(B = 0, G = 0, R = 0, X = 0.1815) annotation(
    Placement(visible = true, transformation(origin = {-4, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  OpenIPSL.Electrical.Buses.Bus bus1(V_b = 20, displayPF = true) annotation(
    Placement(visible = true, transformation(origin = {51, -1}, extent = {{-11, -11}, {11, 11}}, rotation = 0)));
  inner OpenIPSL.Electrical.SystemBase SysData(S_b = 300, fn = 50) annotation(
    Placement(visible = true, transformation(origin = {-83, 83}, extent = {{-15, -13}, {15, 13}}, rotation = 0)));
  
  parameter Real X_leakage_tr (final unit= "per unit")= 0.1 "leakge reactance of transformer";
  parameter Real length (final unit= "km")= 64 "length of transmission line";
  parameter Real Xtl_perkm (final unit= "ohm/km")= 0.5 "per km reactanmce of transmission line";
  OpenIPSL.Electrical.Buses.Bus bus2(V_b = 20, displayPF = true)  annotation(
    Placement(visible = true, transformation(origin = {-56, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
 OpenIPSL.Electrical.Buses.Bus bus3(V_b = 20, displayPF = true)  annotation(
    Placement(visible = true, transformation(origin = {-20, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
 OpenIPSL.Electrical.Buses.Bus bus4(V_b = 20, displayPF = true)  annotation(
    Placement(visible = true, transformation(origin = {14, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
equation
  connect(twoWindingTransformer2.p, bus4.p) annotation(
    Line(points = {{22, 0}, {12, 0}, {12, 0}, {14, 0}}, color = {0, 0, 255}));
  connect(pwLine1.n, bus4.p) annotation(
    Line(points = {{6, 0}, {14, 0}, {14, 0}, {14, 0}}, color = {0, 0, 255}));
  connect(twoWindingTransformer2.n, bus1.p) annotation(
    Line(points = {{43, 0}, {52, 0}}, color = {0, 0, 255}));
  connect(bus3.p, pwLine1.p) annotation(
    Line(points = {{-20, 0}, {-14, 0}, {-14, 0}, {-12, 0}}, color = {0, 0, 255}));
  connect(twoWindingTransformer1.n, bus3.p) annotation(
    Line(points = {{-28, 0}, {-22, 0}, {-22, 0}, {-20, 0}}, color = {0, 0, 255}));
  connect(twoWindingTransformer1.p, bus2.p) annotation(
    Line(points = {{-51, 0}, {-56, 0}}, color = {0, 0, 255}));
  connect(motor1.p, bus1.p) annotation(
    Line(points = {{70, 16}, {56, 16}, {56, 0}, {52, 0}}, color = {0, 0, 255}));
  connect(motor2.p, bus1.p) annotation(
    Line(points = {{68, -26}, {56, -26}, {56, 0}, {52, 0}, {52, 0}}, color = {0, 0, 255}));
  connect(generator.p, bus2.p) annotation(
    Line(points = {{-66, 0}, {-58, 0}, {-58, 0}, {-56, 0}}, color = {0, 0, 255}));
  connect(motor2.vf, motor2.vf0) annotation(
    Line(points = {{90, -21}, {96, -21}, {96, -3}, {86, -3}, {86, -15}, {86, -15}, {86, -15}}, color = {0, 0, 127}));
  connect(motor2.pm0, motor2.pm) annotation(
    Line(points = {{86, -37}, {86, -37}, {86, -43}, {94, -43}, {94, -31}, {90, -31}, {90, -31}}, color = {0, 0, 127}));
  connect(motor1.vf, motor1.vf0) annotation(
    Line(points = {{92, 21}, {98, 21}, {98, 35}, {88, 35}, {88, 27}, {88, 27}, {88, 27}}, color = {0, 0, 127}));
  connect(motor1.pm, motor1.pm0) annotation(
    Line(points = {{92, 11}, {96, 11}, {96, 1}, {88, 1}, {88, 5}, {88, 5}}, color = {0, 0, 127}));
  connect(generator.vf, generator.vf0) annotation(
    Line(points = {{-88, 5}, {-98, 5}, {-98, 37}, {-84, 37}, {-84, 9}, {-84, 9}, {-84, 11}}, color = {0, 0, 127}));
  connect(generator.pm, generator.pm0) annotation(
    Line(points = {{-88, -5}, {-96, -5}, {-96, -27}, {-84, -27}, {-84, -11}, {-84, -11}}, color = {0, 0, 127}));
  Vmc = twoWindingTransformer1.Vn * (motor1.Vn /twoWindingTransformer2.Vn);
  Xtr1 = X_leakage_tr * (SysData.S_b / twoWindingTransformer1.Sn);
  Xtr2 = X_leakage_tr * (motor1.Vn / Vmc) ^ 2;
  Zb_tl = twoWindingTransformer1.Vn ^ 2 / SysData.S_b;
  Xtl = Xtl_perkm * length / Zb_tl;
  X_M1 = motor1.x1d * (SysData.S_b / motor1.Sn * (motor1.Vn / Vmc) ^ 2);
  X_M2 = motor1.x1d * (SysData.S_b / motor2.Sn * (motor1.Vn / Vmc) ^ 2);
//"The  answer may slightly vary due to  rounding off values"
end Ex6_10;
